//
//  mdlWorkOrderSegment.swift
//
//
//  Created by Michiel Carman on 2/16/24.
//


import Fluent
import Vapor
import Foundation
import FluentKit

final class mdlWorkOrderSegment: Model, Content {
    static let schema = "workOrderSegment"
    
    @ID(custom: "id", generatedBy: .database) var id: Int?
    
    @Parent(key: "workOrderId") var workorder: mdlWorkOrder
    @Parent(key: "segmentId") var segment: mdlSegment
    
    @Children(for: \.$segment) var parts: [mdlWorkOrderPart]
    @Children(for: \.$segment) var inspections: [mdlInspection]
    @Children(for: \.$segment) var samples: [mdlOilSample]
    @Children(for: \.$segment) var consumptions: [mdlConsumption]
    
    @Timestamp(key: "createDate", on: .create) var createdate: Date?
    @Field(key: "createUserId") var createuserid: Int?
    @Timestamp(key: "updateDate", on: .update) var updatedate: Date?
    @Field(key: "updateUserId") var updateuserid: Int?
    
    init() { }
    
    init(id: Int? = nil,
         workorderid: Int,
         segmentid: Int,
         createuserid: Int? = nil,
         updateuserid: Int? = nil
    ) {
        self.id = id
        self.$workorder.$id.value = workorderid
        self.$segment.$id.value = segmentid
        self.createuserid = createuserid
        self.updateuserid = updateuserid
    }
}
extension mdlWorkOrderSegment{
    struct Create: AsyncMigration {
        func prepare(on database: Database) async throws {
            try await database.schema("workOrderSegment")
                .field("id", .int, .identifier(auto: true))
                .field("workOrderId", .int)
                .field("segmentId", .int)
                .field("createDate", .datetime)
                .field("createUserId", .int)
                .field("updateDate", .datetime)
                .field("updateUserId", .int)
                .create()
        }
        
        func revert(on database: Database) async throws {
            try await database.schema("workOrderSegment").delete()
        }
    }
    public static func ObjQuery(req: Request) async throws -> QueryBuilder<mdlWorkOrderSegment>{
        
        let query = mdlWorkOrderSegment.query(on: req.db)
            .with(\.$parts)
            .with(\.$inspections)
            .with(\.$samples)
            .with(\.$consumptions)
        
        if let x = req.parameters.get("x"){
            let decryptedString = try CustomCrypto.DecryptString(input: x)
            let array =  decryptedString.components(separatedBy: ":")
            ///This call is the standard get by id call
            if (array.count == 1){
                let id = Int(array[0])!
                return query.filter(\.$id == id)
            }
            ///Optional else if if there are multiple parameters in the call
            ///You must include an else for each call that has parameters
            ///Need to check the endpoint to get the right filter statements
            ///else if(x.count == 2){
            ///    let username = x[0]
            ///    let password = x[1]
            ///    return query.filter(\.$username == username).filter(\.$password == password)
            ///}
            else{
                throw Abort(.badRequest)
            }
            
        }
        else{
            return query
        }
    }
}

